﻿
using System.Collections.Generic;
namespace HeuristicLab.Problems.RoutePlanning.Graph {
  interface IGraph {
    void AddVertex(Vertex vertex);
    Vertex GetVertex(long id);
    void AddEdge(long startId, long endId);
    void RemoveEdge(long startId, long endId);
    bool HasEdge(long startId, long endId);
    Edge<Vertex> GetEdge(long startId, long endId);
    List<Edge<Vertex>> GetEdges(long vertexId);
    List<Edge<Vertex>> GetInEdges(long vertexId);
    List<Edge<Vertex>> GetOutEdges(long vertexId);
    Dictionary<long, float> GetNeighborsWithWeight(long id);
    Dictionary<long, float> GetNeighborsWithWeightReversed(long id);
    int GetOutDegree(long id);
    int GetInDegree(long id);
  }
}
